      function lchoose(n, k)
      real*8 n, k
c
Cf2py intent(in) n
Cf2py intent(in) k
Cf2py intent(out) l
c
      real*8 lchoose
      lchoose = lgamma(n + 1) - lgamma(n - k + 1) - lgamma(k + 1)
      return
      end

      function alnorm ( x, upper )
c
Cf2py intent(in) x
Cf2py intent(in) upper
Cf2py intent(out) alnorm
c
c*********************************************************************72
c
cc ALNORM computes the cumulative density of the standard normal distribution.
c
c  Modified:
c
c    28 March 1999
c
c  Author:
c
c    David Hill
c    Modifications by John Burkardt
c
c  Reference:
c
c    David Hill,
c    Algorithm AS 66:
c    The Normal Integral,
c    Applied Statistics,
c    Volume 22, Number 3, 1973, pages 424-427.
c
c  Parameters:
c
c    Input, double precision X, is one endpoint of the semi-infinite interval
c    over which the integration takes place.
c
c    Input, logical UPPER, determines whether the upper or lower
c    interval is to be integrated:
c    .TRUE.  => integrate from X to + Infinity;
c    .FALSE. => integrate from - Infinity to X.
c
c    Output, double precision ALNORM, the integral of the standard normal
c    distribution over the desired interval.
c
      implicit none

      double precision a1
      parameter ( a1 = 5.75885480458D+00 )
      double precision a2
      parameter ( a2 = 2.62433121679D+00 )
      double precision a3
      parameter ( a3 = 5.92885724438D+00 )
      double precision alnorm
      double precision b1
      parameter ( b1 = -29.8213557807D+00 )
      double precision b2
      parameter ( b2 = 48.6959930692D+00 )
      double precision c1
      parameter ( c1 = -0.000000038052D+00 )
      double precision c2
      parameter ( c2 = 0.000398064794D+00 )
      double precision c3
      parameter ( c3 = -0.151679116635D+00 )
      double precision c4
      parameter ( c4 = 4.8385912808D+00 )
      double precision c5
      parameter ( c5 = 0.742380924027D+00 )
      double precision c6
      parameter ( c6 = 3.99019417011D+00 )
      double precision con
      parameter ( con = 1.28D+00 )
      double precision d1
      parameter ( d1 = 1.00000615302D+00 )
      double precision d2
      parameter ( d2 = 1.98615381364D+00 )
      double precision d3
      parameter ( d3 = 5.29330324926D+00 )
      double precision d4
      parameter ( d4 = -15.1508972451D+00 )
      double precision d5
      parameter ( d5 = 30.789933034D+00 )
      double precision ltone
      parameter ( ltone = 7.0D+00 )
      double precision p
      parameter ( p = 0.398942280444D+00 )
      double precision q
      parameter ( q = 0.39990348504D+00 )
      double precision r
      parameter ( r = 0.398942280385D+00 )
      logical up
      logical upper
      double precision utzero
      parameter ( utzero = 18.66D+00 )
      double precision x
      double precision y
      double precision z

      up = upper
      z = x

      if ( z .lt. 0.0D+00 ) then
        up = .not. up
        z = - z
      end if

      if ( z .gt. ltone .and. 
     &  ( ( .not. up ) .or. utzero .lt. z ) ) then

        if ( up ) then
          alnorm = 0.0D+00
        else
          alnorm = 1.0D+00
        end if

        return

      end if

      y = 0.5D+00 * z * z

      if ( z .le. con ) then

        alnorm = 0.5D+00 - z * ( p - q * y
     &    / ( y + a1 + b1 
     &    / ( y + a2 + b2 
     &    / ( y + a3 ))))

      else

        alnorm = r * dexp ( - y )
     &    / ( z + c1 + d1
     &    / ( z + c2 + d2
     &    / ( z + c3 + d3
     &    / ( z + c4 + d4
     &    / ( z + c5 + d5
     &    / ( z + c6 ))))))

      end if

      if ( .not. up ) then
        alnorm = 1.0D+00 - alnorm
      end if

      return
      end

      logical function is_infinite(A)
      real*8 A
c
Cf2py intent(in) A
Cf2py intent(out) is_infinite
c
      if (A .eq. A + 1) then
        is_infinite = .TRUE.
      else
        is_infinite = .FALSE.
      endif
      return
      end

      logical function is_nonint(A)
      real*8 A
c
Cf2py intent(in) A
Cf2py intent(out) is_nonint
c
      if (abs(A) - floor(A + 0.5) .gt. 1e-7) then
        is_nonint = .TRUE.
      else
        is_nonint = .FALSE.
      endif
      return
      end

      logical function is_negnonint(A)
      real*8 A
c
Cf2py intent(in) A
Cf2py intent(out) is_negnonint
c
      logical is_nonint
      external is_nonint
      if ((A .lt. 0) .OR. (is_nonint(A))) then
        is_negnonint = .TRUE.
      else
        is_negnonint = .FALSE.
      endif
      return
      end

      real*8 function pdhyper (x, NR, NB, n, log_p)
      real*8 x, NR, NB, n
      logical log_p
c
Cf2py intent(in) x
Cf2py intent(in) NR
Cf2py intent(in) NB
Cf2py intent(in) n
Cf2py intent(in) log_p
Cf2py intent(out) pdhyper
c
      real*8 sum, term, x_

      sum = 0
      term = 1
      x_ = x
      do 10 while ((x_ .gt. 0) .AND. (term .ge. EPSILON(term) * sum))
        term = term * (x_ * (NB - n + x_) / (n + 1 - x) / (NR + 1 - x_))
        sum = sum + term
        x_ = x_ - 1
10    continue
      sum = sum + 1
      if (log_p) then
        pdhyper = log(sum)
      else
        pdhyper = sum
      endif
      return 
      end

      real*8 function phyper(x, NR, NB, n, lower_tail, log_p)
      real*8 x, NR, NB, n
      logical lower_tail, log_p
c
Cf2py intent(in) x
Cf2py intent(in) NR
Cf2py intent(in) NB
Cf2py intent(in) n
Cf2py intent(in) lower_tail
Cf2py intent(in) log_p
Cf2py intent(out) phyper
c
      real*8 x_i, NR_i, NB_i, n_i, old_NB, dh, pdh, dhyper, pdhyper,
     &  nan64
      logical is_infinite, lower_tail_i
      external dhyper, pdhyper, is_infinite

      nan64 = transfer(Z'7ff8000000000000', nan64)

      if (isnan(x) .OR. isnan(NR) .OR. isnan(NB) .OR. isnan(n)) then
        phyper = nan64
        go to 10
      endif
      
      x_i = FLOOR(x + 1e-7)
      NR_i = NINT(NR)
      NB_i = NINT(NB)
      n_i = NINT(n)
      lower_tail_i = lower_tail

      
      if ((NR .lt. 0) .OR. (NB .lt. 0) .OR. is_infinite(NR+NB) .OR.
     &    (n .lt. 0) .OR. (n_i .gt. NR_i+NB_i)) then
        phyper = nan64
        go to 10
      endif

      if (x_i*(NR_i+NB_i) .gt. n_i*NR_i) then
        old_NB = NB_i
        NB_i = NR_i
        NR_i = old_NB
        x_i = n_i - x_i - 1
        lower_tail_i = .NOT. lower_tail
      endif

      if (x .lt. 0) then
        phyper = 0
        go to 10
      endif
      if ((x_i .ge. NR_i) .OR. (x_i .ge. n_i)) then
        phyper = 1
      endif

      dh = dhyper(x_i, NR_i, NB_i, n_i, log_p)
      pdh = pdhyper(x_i, NR_i, NB_i, n_i, log_p)

      if (lower_tail_i) then
        if (log_p) then
          phyper = dh + pdh
        else
          phyper = dh * pdh
        endif
      else
        if (log_p) then
          phyper = log(1 - exp(dh + pdh))
        else
          phyper = 0.5 - (dh * pdh) + 0.5
        endif
      endif
10    return
      end

      real*8 function dhyper(x, r, b, n, give_log)
      real*8 x, r, b, n
      logical give_log
c
Cf2py intent(in) x
Cf2py intent(in) r
Cf2py intent(in) b
Cf2py intent(in) n
Cf2py intent(in) give_log
Cf2py intent(out) dhyper
c
      real*8 p, q, p1, p2, p3, x_i, r_i, b_i, n_i, dbinom_raw, nan64,
     &  infinity
      logical is_negnonint
      external is_negnonint, dbinom_raw

      infinity = transfer(Z'7ff0000000000000', infinity)
      nan64 = transfer(Z'7ff8000000000000', nan64)

      if (isnan(x) .OR. isnan(r) .OR. isnan(b) .OR. isnan(n)) then
        dhyper = nan64
        go to 10
      endif

      if (is_negnonint(r) .OR. is_negnonint(b) .OR. is_negnonint(n)
     &   .OR. (n .gt. r+b)) then
        dhyper = nan64
        go to 10
      endif
      if (x .lt. 0) then
        if (give_log) then
          dhyper = -infinity
        else
          dhyper = 0
        endif
        go to 10
      endif

      x_i = REAL(NINT(x), 8)
      r_i = REAL(NINT(r), 8)
      b_i = REAL(NINT(b), 8)
      n_i = REAL(NINT(n), 8)

      if ((n_i .lt. x_i) .OR. (r_i .lt. x_i) .OR. (n-x .gt. b)) then
        dhyper = 0
        go to 10
      endif
      if (n_i .eq. 0) then
        if (x .eq. 0) then
          if (give_log) then
            dhyper = 0.
          else
            dhyper = 1.
          endif
        else
          if (give_log) then
            dhyper = -infinity
          else
            dhyper = 0.
          endif
        endif
        go to 10
      endif

      p = n_i / (r_i+b_i)
      q = (r_i+b_i-n_i) / (r_i+b_i)

      p1 = dbinom_raw(x_i, r_i, p, q, give_log)
      p2 = dbinom_raw(n_i-x_i, b_i, p, q, give_log)
      p3 = dbinom_raw(n_i, r_i+b_i, p, q, give_log)

      if (give_log) then
        dhyper = p1 + p2 - p3
      else
        dhyper = p1 * p2 / p3
      endif
10    return
      end


      real*8 function dbinom_raw(x, n, p, q, give_log)
      real*8 x, n, p, q
      logical give_log
c
Cf2py intent(in) x
Cf2py intent(in) n
Cf2py intent(in) p
Cf2py intent(in) q
Cf2py intent(in) give_log
Cf2py intent(out) dbinom_raw
c
      real*8, PARAMETER :: LN_2PI = 1.837877066409345483560659472811
      real*8 lf, lc, stirlerr, bd0, infinity
      external stirlerr, bd0

      infinity = transfer(Z'7ff0000000000000', infinity)

      if (p .eq. 0) then
        if (x .eq. 0) then
          if (give_log) then
            dbinom_raw = 0.
          else
            dbinom_raw = 1.
          endif
        else
          if (give_log) then
            dbinom_raw = -infinity
          else
            dbinom_raw = 0.
          endif
        endif
        go to 10
      endif
      if (q .eq. 0) then
        if (x .eq. n) then
          if (give_log) then
            dbinom_raw = 0.
          else
            dbinom_raw = 1.
          endif
        else
          if (give_log) then
            dbinom_raw = -infinity
          else
            dbinom_raw = 0.
          endif
        endif
        go to 10
      endif

      if (x .eq. 0) then
        if (n .eq. 0) then
          if (give_log) then
            dbinom_raw = 0.
          else
            dbinom_raw = 1.
          endif
          go to 10
        endif
        if (p .lt. 0.1) then
          lc = -bd0(n, n*q) - n*p
        else
          lc = n*log(q)
        endif
        if (give_log) then
          dbinom_raw = lc
        else
          dbinom_raw = exp(lc)
        endif
        go to 10  
      endif

      if (x .eq. n) then
        if (q .lt. 0.1) then
          lc = -bd0(n, n*p) - n*q
        else
          lc = n*log(p)
        endif
        if (give_log) then
          dbinom_raw = lc
        else
          dbinom_raw = exp(lc)
        endif
        go to 10
      endif
      if ((x .lt. 0) .OR. (x .gt. n)) then
        if (give_log) then
          dbinom_raw = -infinity
        else
          dbinom_raw = 0.
        endif
        go to 10
      endif

c n*p or n*q can underflow to zero if n and p or q are small.  This
c used to occur in dbeta, and gives NaN as from R 2.3.0.
      lc = stirlerr(n)-stirlerr(x)-stirlerr(n-x)-bd0(x,n*p)-bd0(n-x,n*q)

c f = (M_2PI*x*(n-x))/n; could overflow or underflow
c Upto R 2.7.1:
c lf = log(M_2PI) + log(x) + log(n-x) - log(n);
c -- following is much better for  x << n :
      lf = LN_2PI + log(x) + log(1 - x/n)
      if (give_log) then
        dbinom_raw = lc - 0.5 * lf
      else
        dbinom_raw = exp(lc - 0.5 * lf)
      endif
10    return
      end

      real*8 function stirlerr(n)
      real*8 n
c
Cf2py intent(in) n
Cf2py intent(out) stirlerr
c
      real*8 nn
c 1/12
      real*8, PARAMETER :: S0 = 0.083333333333333333333
c 1/360
      real*8, PARAMETER :: S1 = 0.00277777777777777777778
c 1/1260
      real*8, PARAMETER :: S2 = 0.00079365079365079365079365
c 1/1680
      real*8, PARAMETER :: S3 = 0.000595238095238095238095238
c 1/1188
      real*8, PARAMETER :: S4 = 0.0008417508417508417508417508
      real*8, PARAMETER :: LN_SQRT_2PI = 
     &  0.918938533204672741780329736406
c error for 0, 0.5, 1.0, 1.5, ..., 14.5, 15.0.
      real*8, dimension(0:30) :: sferr_halves
      sferr_halves(0:30) = (/ 0.0,
     &  0.1534264097200273452913848,
     &  0.0810614667953272582196702,
     &  0.0548141210519176538961390,
     &  0.0413406959554092940938221,
     &  0.03316287351993628748511048,
     &  0.02767792568499833914878929,
     &  0.02374616365629749597132920,
     &  0.02079067210376509311152277,
     &  0.01848845053267318523077934,
     &  0.01664469118982119216319487,
     &  0.01513497322191737887351255,
     &  0.01387612882307074799874573,
     &  0.01281046524292022692424986,
     &  0.01189670994589177009505572,
     &  0.01110455975820691732662991,
     &  0.010411265261972096497478567,
     &  0.009799416126158803298389475,
     &  0.009255462182712732917728637,
     &  0.008768700134139385462952823,
     &  0.008330563433362871256469318,
     &  0.007934114564314020547248100,
     &  0.007573675487951840794972024,
     &  0.007244554301320383179543912,
     &  0.006942840107209529865664152,
     &  0.006665247032707682442354394,
     &  0.006408994188004207068439631,
     &  0.006171712263039457647532867,
     &  0.005951370112758847735624416,
     &  0.005746216513010115682023589,
     &  0.005554733551962801371038690/)

      if (n .le. 15.0) then
        nn = n + n
        if (nn .eq. INT(nn)) then
          stirlerr = sferr_halves (INT(nn))
        else
          stirlerr = LOG_GAMMA(n+1) - (n+0.5) * log(n) + n - LN_SQRT_2PI
        endif
        go to 10
      endif

      nn = n*n
      if (n .gt. 500) then
        stirlerr = (S0 - S1/nn) / n
      else if (n .gt. 80) then
        stirlerr = (S0 - (S1 - S2/nn) / nn) / n
      else if (n .gt. 35) then
        stirlerr = (S0 - (S1 - (S2 - S3/nn) / nn) / nn) / n
      else
        stirlerr = (S0 - (S1 - (S2 - (S3 - S4/nn) / nn) / nn) / nn) / n
      endif
10    return
      end

      real*8 function bd0(x, np)
      real*8 x, np
c
Cf2py intent(in) x
Cf2py intent(in) np
Cf2py intent(out) bd0
c
      real*8 ej, s, s1, v, nan64
      integer j
      logical is_infinite
      external is_infinite

      nan64 = transfer(Z'7ff8000000000000', nan64)

      if (is_infinite(x) .OR. is_infinite(np) .OR. (np .eq. 0)) then
        bd0 = nan64
        go to 100
      endif

      if (abs(x-np) .lt. 0.1 * (x+np)) then
        v = (x - np) / (x + np)
        s = (x - np) * v
        if (abs(s) .lt. TINY(s)) then
          bd0 = s
          go to 100
        endif
        ej = 2 * x * v
        v = v * v
        do 10 j = 1, 1000
          ej = ej * v
          s1 = s + ej / (SHIFTL(j, 1) + 1)
          if (s1 .eq. s) then
            bd0 = s1
            go to 100
          endif
          s = s1
10      continue
      endif
      bd0 = x * log(x / np) + np - x
100   return
      end

c     n = length(gdat) i.e. number of markers and log-ratio
c     k is the neighborhood width
c     oSD = how far the outlier is to the nearest observation
c     sSD = how close should it be moved
c     nchr = number of chromosomes
c     cfrq = number of probes in respective chromosomes
      subroutine smoothLR(n, gdat, nchr, cfrq, sgdat, k, oSD, sSD)
      integer n, nchr, cfrq(nchr), k
      real*8 gdat(n), sgdat(n), oSD, sSD
c
Cf2py integer intent(hide),depend(gdat) :: n=shape(gdat,0)
Cf2py intent(in) gdat
Cf2py integer intent(hide),depend(cfrq) :: nchr=shape(cfrq,0)
Cf2py intent(in) cfrq
Cf2py real*8 intent(in,out),depend(n) :: sgdat
Cf2py intent(in) k
Cf2py intent(in) oSD
Cf2py intent(in) sSD
c
      integer i, j, ilo, ihi, k1, k2, j1, ic, cilo, cihi
      real*8 mnnbd, mxnbd, distij, xmed

c     temporary array for finding median
      real*8, allocatable :: xnbhd(:)

      k2 = 2*k + 1
      allocate(xnbhd(k2))

c     initial values for start and end of chromosomes
      cilo = 1
      cihi = 0
c     loop over chromomsomes
      do 100 ic = 1, nchr
c     end of the current chromosome
         cihi = cihi + cfrq(ic)
         do 50 i = cilo, cihi
c     range of the neighborhood
            ilo = max(cilo, i-k)
            ihi = min(cihi, i+k)
c     check if ith observation is an outlier
c     initialize the distances to be large
            mxnbd = 100*oSD
            mnnbd = 100*oSD
            do 10 j = ilo, ihi
               if (j .ne. i) then
c     calculate distance from between ith and jth obsn
                  distij = gdat(i) - gdat(j)
c     if distance is less than oSD no smoothing necessary
                  if (abs(distij) .le. oSD) then
                     sgdat(i) = gdat(i)
                     go to 50
c     otherwise calculate distances from above and below
                  else
c     mxnbd is distance from above
                     if (distij .lt. mxnbd) mxnbd = distij
c     mnnbd is distance from below
                     if (-distij .lt. mnnbd) mnnbd = -distij
                  endif
               endif
 10         continue
c     if all the points in the nbhd are above than mxnbd will be negative
c     and mnnbd will be greater than oSD. Vice versa if all points below
c     
c     If both are negative then the ith point is singleton in the middle 
c     but distance oSD away from all points in the nbhd. No smoothing done.
            if ((mxnbd .le. 0) .and. (mnnbd .le. 0)) then
               sgdat(i) = gdat(i)
               go to 50
            else
c     calculate the median of the nbhd
c     number of points in the nbhd
               k1 = ihi - ilo + 1
c     get the data into temporary array
               do 20 j = ilo, ihi
                  xnbhd(j-ilo+1) = gdat(j)
 20            continue
c     sort the data
               call sort(xnbhd, 1, k1)
c     median is the midpoint if n is odd and average of the two if even
               j1 = k1/2
               if (k1 .eq. 2*j1) then
                  xmed = (xnbhd(j1) + xnbhd(j1+1))/2
               else
                  xmed = xnbhd(j1+1)
               endif
c     if point is above the nbhd bring it down
               if (mxnbd .gt. 0) sgdat(i) = xmed + sSD
c     if point is below the nbhd bring it up
               if (mnnbd .gt. 0) sgdat(i) = xmed - sSD
            endif
 50      continue
c     beginning of next chromosome
         cilo = cilo + cfrq(ic)
 100  continue
      deallocate(xnbhd)

      return
      end

      subroutine bsegp(n, gendat, ostat, pval, ng, tol)
      integer n, ng
      real*8 gendat(n), ostat, pval, tol
c
Cf2py integer intent(in),depend(gendat) :: n=shape(gendat,0)
Cf2py intent(in) gendat
Cf2py intent(in,out) ostat
Cf2py intent(in,out) pval
Cf2py intent(in) ng
Cf2py intent(in) tol
c
      real*8 btmax, btailp
      external btmax, btailp

      ostat = btmax(n, gendat)
c      call dblepr("Max Stat",8,ostat,1)
      pval = btailp(ostat, n, ng, tol)
      if (pval .gt. 1) pval = 1.0d0

      return
      end

      real*8 function btmax(n, x)
      integer n
      real*8 x(n)
c
Cf2py integer intent(in),depend(x) :: n=shape(x,0)
Cf2py intent(in) x
Cf2py intent(out) btmax
c
      integer i
      real*8 sumxi, btmaxi, dn, di, ostat

      sumxi = x(1)
      ostat = 0.0
      dn = dfloat(n)
      di = 1.0
      do 20 i = 2,n-2
         di = di + 1.0
         sumxi = sumxi + x(i)
         btmaxi = dn*(sumxi**2)/(di*(dn-di))
         if (ostat .lt. btmaxi) then
            ostat = btmaxi
c            ibseg = i
         endif
 20   continue
      btmax = sqrt(ostat)

      return
      end

c     pseudo confidence interval based on permutations
      subroutine bsegci(n, k, sumxk, x, px, sr, vfact, nperm, bsloc)
      integer n, k, sr(2), nperm, bsloc(nperm)
      real*8 sumxk, x(n), px(n), vfact(n)
c
Cf2py integer intent(in),depend(x) :: n=shape(x,0)
Cf2py intent(in) k
Cf2py intent(in) sumxk
Cf2py intent(in) x
Cf2py real*8 intent(in),depend(n) :: px
Cf2py intent(in) sr
Cf2py real*8 intent(in),depend(n) :: vfact
Cf2py integer intent(in),depend(bsloc) :: nperm=shape(bsloc,0)
Cf2py intent(in,out) bsloc
c
      integer k1, nk, np, ibseg

      call random_seed()
      k1 = k+1
      nk = n-k
      do 10 np = 1, nperm
         call xperm(k,x,px)
         call xperm(nk,x(k1),px(k1))
         call btmxci(n,k,sr,px,vfact,ibseg,sumxk)
         bsloc(np) = ibseg
 10   continue

      return
      end

      subroutine btmxci(n,k,sr,x,vfact,ibseg,sumxk)
      integer n,k,sr(2),ibseg
      real*8 x(n),vfact(n),sumxk
c
Cf2py integer intent(in),depend(x) :: n=shape(x,0)
Cf2py intent(in) k
Cf2py intent(in) sr
Cf2py intent(in) x
Cf2py real*8 intent(in),depend(n) :: vfact
Cf2py intent(in,out) ibseg
Cf2py intent(in) sumxk
c
      integer i
      real*8 sumxi, ostat, btmaxi

      ostat = vfact(k)*(sumxk**2)
      ibseg = k
      sumxi = sumxk
      do 10 i = k-1,sr(1),-1
         sumxi = sumxi - x(i+1)
         btmaxi = vfact(i)*(sumxi**2)
         if (ostat .lt. btmaxi) then
            ostat = btmaxi
            ibseg = i
         endif
 10   continue

      sumxi = sumxk
      do 20 i = k+1,sr(2)
         sumxi = sumxi + x(i)
         btmaxi = vfact(i)*(sumxi**2)
         if (ostat .lt. btmaxi) then
            ostat = btmaxi
            ibseg = i
         endif
 20   continue
      ostat = sqrt(ostat)

      return
      end

C=== This was 'sort()' in  gamfit's  mysort.f  [or sortdi() in sortdi.f ] :
C
C     a[] is real*8 because the caller reuses a double (sometimes v[] itself!)

      subroutine sort (v,ii,jj,n)
c
Cf2py intent(in,out) v(n)
Cf2py intent(in) ii
Cf2py intent(in) jj
Cf2py integer intent(hide),depend(v) :: n=shape(v, 0)
c
c     Puts into a the permutation vector which sorts v into
c     increasing order.  Only elements from ii to jj are considered.
c     Arrays iu(k) and il(k) permit sorting up to 2**(k+1)-1 elements
c
c     This is a modification of CACM algorithm #347 by R. C. Singleton,
c     which is a modified Hoare quicksort.
c
      integer ii,jj,n
      real*8 v(n)
c
      integer iu(20),il(20)
      integer m,i,j,ij,k,l
      real*8 vt, vtt

      m=1
      i=ii
      j=jj
 10   if (i.ge.j) go to 80
 20   k=i
      ij=(j+i)/2
      vt=v(ij)
      if (v(i).le.vt) go to 30
      v(ij)=v(i)
      v(i)=vt
      vt=v(ij)
 30   l=j
      if (v(j).ge.vt) go to 50
      v(ij)=v(j)
      v(j)=vt
      vt=v(ij)
      if (v(i).le.vt) go to 50
      v(ij)=v(i)
      v(i)=vt
      vt=v(ij)
      go to 50
 40   v(l)=v(k)
      v(k)=vtt
 50   l=l-1
      if (v(l).gt.vt) go to 50
      vtt=v(l)
 60   k=k+1
      if (v(k).lt.vt) go to 60
      if (k.le.l) go to 40
      if (l-i.le.j-k) go to 70
      il(m)=i
      iu(m)=l
      i=k
      m=m+1
      go to 90
 70   il(m)=k
      iu(m)=j
      j=l
      m=m+1
      go to 90
 80   m=m-1
      if (m.eq.0) return
      i=il(m)
      j=iu(m)
 90   if (j-i.gt.10) go to 20
      if (i.eq.ii) go to 10
      i=i-1
 100  i=i+1
      if (i.eq.j) go to 80
      vt=v(i+1)
      if (v(i).le.vt) go to 100
      k=i
 110  v(k+1)=v(k)
      k=k-1
      if (vt.lt.v(k)) go to 110
      v(k+1)=vt
      go to 100
      end

C=== This was 'sort()' in  gamfit's  mysort.f  [or sortdi() in sortdi.f ] :
C
C     a[] is real*8 because the caller reuses a double (sometimes v[] itself!)
      subroutine sort_i (v,a,ii,jj,n)
c
Cf2py intent(in) v(n)
Cf2py intent(in,out) a(n)
Cf2py intent(in) ii
Cf2py intent(in) jj
Cf2py integer intent(hide),depend(v) :: n=shape(v, 0)
c
c     Puts into a the permutation vector which sorts v into
c     increasing order.  Only elements from ii to jj are considered.
c     Arrays iu(k) and il(k) permit sorting up to 2**(k+1)-1 elements
c
c     This is a modification of CACM algorithm #347 by R. C. Singleton,
c     which is a modified Hoare quicksort.
c
      integer ii,jj,n,a(n)
      real*8 v(n)
c
      integer iu(20),il(20)
      integer t,tt, m,i,j,ij,k,l
      real*8 vt, vtt

      m=1
      i=ii
      j=jj
 10   if (i.ge.j) go to 80
 20   k=i
      ij=(j+i)/2
      t=a(ij)
      vt=v(ij)
      if (v(i).le.vt) go to 30
      a(ij)=a(i)
      a(i)=t
      t=int(a(ij))
      v(ij)=v(i)
      v(i)=vt
      vt=v(ij)
 30   l=j
      if (v(j).ge.vt) go to 50
      a(ij)=a(j)
      a(j)=t
      t=a(ij)
      v(ij)=v(j)
      v(j)=vt
      vt=v(ij)
      if (v(i).le.vt) go to 50
      a(ij)=a(i)
      a(i)=t
      t=a(ij)
      v(ij)=v(i)
      v(i)=vt
      vt=v(ij)
      go to 50
 40   a(l)=a(k)
      a(k)=tt
      v(l)=v(k)
      v(k)=vtt
 50   l=l-1
      if (v(l).gt.vt) go to 50
      tt=a(l)
      vtt=v(l)
 60   k=k+1
      if (v(k).lt.vt) go to 60
      if (k.le.l) go to 40
      if (l-i.le.j-k) go to 70
      il(m)=i
      iu(m)=l
      i=k
      m=m+1
      go to 90
 70   il(m)=k
      iu(m)=j
      j=l
      m=m+1
      go to 90
 80   m=m-1
      if (m.eq.0) return
      i=il(m)
      j=iu(m)
 90   if (j-i.gt.10) go to 20
      if (i.eq.ii) go to 10
      i=i-1
 100  i=i+1
      if (i.eq.j) go to 80
      t=a(i+1)
      vt=v(i+1)
      if (v(i).le.vt) go to 100
      k=i
 110  a(k+1)=a(k)
      v(k+1)=v(k)
      k=k-1
      if (vt.lt.v(k)) go to 110
      a(k+1)=t
      v(k+1)=vt
      go to 100
      end

c     Ternary segmentation with permutation reference distribution
      subroutine fndcpt(n,x,tss,nperm,cpval,ncpt,icpt,ibin,
     1     hybrid,al0,hk,delta,ngrid,sbn,sbdry,tol)
      integer n,nperm,ncpt(1),icpt(2),al0,hk,ngrid,sbn,sbdry(sbn)
      logical ibin,hybrid
      real*8 x(n),tss,cpval,delta,tol
c
Cf2py integer intent(hide),depend(x) :: n=shape(x,0)
Cf2py intent(in) x
Cf2py intent(in) tss
Cf2py intent(in) nperm
Cf2py intent(in) cpval
Cf2py intent(in,out) ncpt
Cf2py intent(in,out) icpt
Cf2py intent(in) ibin
Cf2py intent(in) hybrid
Cf2py intent(in) al0
Cf2py intent(in) hk
Cf2py intent(in) delta
Cf2py intent(in) ngrid
Cf2py integer intent(hide),depend(sbdry) :: sbn=shape(sbdry,0)
Cf2py intent(in) sbdry
Cf2py intent(in) tol
c
      integer np,nrej,nrejc,iseg(2),n1,n2,n12,l,k
      real*8 ostat,ostat1,pstat,tpval,pval1,pval2,px(n),sx(n)

c     new functions to replace tmax and htmax (also tmaxo replaces tmax1)
      real*8 tailp, tmaxp, htmaxp, tpermp
      external tailp, tmaxp, htmaxp, tpermp

      call random_seed()

      nrej = 0
      ncpt(1) = 0

c      call tmax1(n,twon,x,tss,sx,tx,iseg,ostat,ibin)
      call tmaxo(n,x,tss,sx,iseg,ostat,al0,ibin)
      ostat1 = sqrt(ostat)
      ostat = ostat * 0.99999
c      call dblepr("Max Stat",8,ostat,1)
c      call intpr("Location",8,iseg,2)

c     if maximal t-statistic is too small (for now use 0.1) don't split
      if (ostat1 .le. 0.1) go to 500
c     if maximal t-statistic is too large (for now use 7.0) split
c     also make sure it's not affected by outliers i.e. small seglength
      l = min(iseg(2) - iseg(1), n - iseg(2) + iseg(1))
      if ((ostat1 .ge. 7.0) .and. (l .ge. 10)) go to 200
c     o.w calculate p-value and decide if & how data are segmented
      if (hybrid) then
         pval1 = tailp(ostat1, delta, n, ngrid, tol)
         if (pval1 .gt. cpval) go to 500
         pval2 = cpval - pval1
         nrejc = int(pval2*dfloat(nperm))
         k=nrejc*(nrejc+1)/2 + 1
         do 50 np = 1,nperm
            call xperm(n,x,px)
c            pstat = htmax(n,twon,hk,tss,px,sx,tx,ibin)
            pstat = htmaxp(n,hk,tss,px,sx,al0,ibin)
            if (ostat.le.pstat) then
               nrej = nrej + 1
               k = k + 1
            endif
            if (nrej.gt.nrejc) go to 500
            if (np .ge. sbdry(k)) go to 200
 50      continue
      else
         nrejc = int(cpval*dfloat(nperm))
         k=nrejc*(nrejc+1)/2 + 1
         do 100 np = 1,nperm
            call xperm(n,x,px)
c            pstat = tmax(n,twon,tss,px,sx,tx,ibin)
            pstat = tmaxp(n,tss,px,sx,al0,ibin)
c     call dblepr("Perm Max Stat",13,pstat,1)
            if (ostat.le.pstat) then
               nrej = nrej + 1
               k = k + 1
            endif
c     call intpr("num rej",7,nrej,1)
            if (nrej.gt.nrejc) go to 500
            if (np .ge. sbdry(k)) go to 200
 100     continue
      endif
 200  if (iseg(2).eq.n) then
         ncpt(1) = 1
         icpt(1) = iseg(1)
      else
         if(iseg(1).eq.0) then
            ncpt(1) = 1
            icpt(1) = iseg(2)
         else
            l = 1
            n1 = iseg(1)
            n12 = iseg(2)
            n2 = n12 - n1
            tpval = tpermp(n1,n2,n12,x(l),px,nperm)
c            call dblepr("binseg p-value",14,tpval,1)
            if (tpval.le.cpval) then
               ncpt(1) = 1
               icpt(1) = iseg(1)
            endif
            l = iseg(1) + 1
            n12 = n - iseg(1)
            n2 = n - iseg(2)
            n1 = n12 - n2
            tpval = tpermp(n1,n2,n12,x(l),px,nperm)
c            call dblepr("binseg p-value",14,tpval,1)
            if (tpval.le.cpval) then
               ncpt(1) = ncpt(1) + 1
               icpt(ncpt(1)) = iseg(2)
            endif
         endif
      endif

 500  return
      end

c     code to permute the data vector
      subroutine xperm(n,x,px)
      integer n
      real*8 x(n),px(n)
c
Cf2py integer intent(in),depend(x) :: n=shape(x,0)
Cf2py intent(in) x
Cf2py real*8 intent(in,out),depend(n) :: px
c
      integer i,j
      real*8 cc,tmpx

      do 10 i = 1,n
         px(i) = x(i)
 10   continue

      do 20 i = n,1,-1
         cc = rand(1)
         j = int(cc*dfloat(i))+1
         tmpx = px(i)
         px(i) = px(j)
         px(j) = tmpx
 20   continue
      return
      end

c     function for the p-value of t-statistics for removing edge effects
      real*8 function tpermp(n1,n2,n,x,px,nperm)
      integer n1,n2,n,nperm
      real*8 x(n),px(n)
c
Cf2py intent(in) n1
Cf2py intent(in) n2
Cf2py integer intent(in),depend(x) :: n=shape(x,0)
Cf2py intent(in) x
Cf2py real*8 intent(in),depend(n) :: px
Cf2py intent(in) nperm
Cf2py intent(out) tpermp
c
      integer np,i,m1,j,nrej
      real*8 xsum1,xsum2,xbar,ostat,pstat,rn1,rn2,rm1,
     1     tstat, tss, rn, cc, tmpx

      rn1 = dfloat(n1)
      rn2 = dfloat(n2)
      rn = rn1 + rn2
      if (n1.eq.1 .or. n2.eq.1) then
         nrej = nperm
         go to 110
      endif
      xsum1 = 0.0
      tss = 0.0
      do 10 i=1,n1
         px(i) = x(i)
         xsum1 = xsum1 + x(i)
         tss = tss + x(i)**2
 10   continue
      xsum2 = 0.0
      do 20 i=n1+1,n
         px(i) = x(i)
         xsum2 = xsum2 + x(i)
         tss = tss + x(i)**2
 20   continue
      xbar = (xsum1 + xsum2)/rn
      tss = tss - rn*(xbar**2)
      if (n1.le.n2) then
         m1 = n1
         rm1 = rn1
         ostat = 0.99999*abs(xsum1/rn1 - xbar)
         tstat = (ostat**2)*rn1*rn/rn2
      else
         m1 = n2
         rm1 = rn2
         ostat = 0.99999*abs(xsum2/rn2 - xbar)
         tstat = (ostat**2)*rn2*rn/rn1
      endif
c      call dblepr("O-Stat",6,ostat,1)
      nrej = 0
      tstat = tstat/((tss-tstat)/(rn-2.0))
c      call dblepr("T-square",8,tstat,1)
c     if observed t is large (> 5) don't bother with permutation p-value
c     also make sure there are enough observations i.e. m1 >= 10
      if ((tstat .gt. 25) .and. (m1 .ge. 10)) go to 110
      do 100 np = 1,nperm
c*******************************************
c     the following is very inefficient
c*******************************************
c         call xperm(n,x,px)
c         xsum1 = 0.0
c         do 30 i=1,m1
c            xsum1 = xsum1 + px(i)
c 30      continue
c*******************************************
c     changed to the following: instead of
c     full permutation sample m1 w.o. repl
c******************************************* 
         xsum1 = 0
         do 30 i = n,n-m1+1,-1
            cc = rand(1)
            j = int(cc*dfloat(i))+1
            tmpx = px(i)
            px(i) = px(j)
            px(j) = tmpx
            xsum1 = xsum1 + px(i)
 30      continue
         pstat = abs(xsum1/rm1 - xbar)
c         call dblepr("P-Stat",6,pstat,1)
         if (ostat.le.pstat) nrej = nrej + 1
 100  continue
 110  tpermp = dfloat(nrej)/dfloat(nperm)

      return
      end

      subroutine getbdry(eta, m, nperm, mb, ibdry, etastr, tol)
      integer m, nperm, mb, ibdry(mb)
      real*8 eta, etastr(m), tol
c
Cf2py intent(in) eta
Cf2py integer intent(hide),depend(etastr) :: m=shape(etastr, 0)
Cf2py intent(in) nperm
Cf2py integer intent(hide),depend(ibdry) :: mb=shape(ibdry, 0)
Cf2py intent(in,out) ibdry
Cf2py intent(in) etastr
Cf2py intent(in) tol
c
      real*8 eta0, etalo, etahi, plo, phi, pexcd
      integer j, l

      l = 1
      ibdry(1) = nperm-int(dfloat(nperm)*eta)
      etastr(1) = eta
      eta0 = eta
      do 20 j = 2,m
         etahi = eta0*1.1
         call etabdry(nperm, etahi, j, ibdry(l+1))
         call pexceed(nperm, j, ibdry(l+1), phi)
         etalo = eta0*0.25
         call etabdry(nperm, etalo, j, ibdry(l+1))
         call pexceed(nperm, j, ibdry(l+1), plo)
         do 10 while ((etahi-etalo)/etalo .gt. tol)
            eta0 = etalo + (etahi-etalo)*(eta-plo)/(phi-plo)
            call etabdry(nperm, eta0, j, ibdry(l+1))
            call pexceed(nperm, j, ibdry(l+1), pexcd)
            if (pexcd .gt. eta) then
               etahi = eta0
               phi = pexcd
            else
               etalo = eta0
               plo = pexcd
            endif
 10      continue
         etastr(j) = eta0
         l = l+j
 20   continue

      return
      end

      subroutine etabdry(nperm, eta0, n1s, ibdry)
      integer nperm, n1s, ibdry(n1s)
      real*8 eta0
c
Cf2py intent(in) nperm
Cf2py intent(in) eta0
Cf2py intent(in) n1s
Cf2py intent(in,out) ibdry
c
      real*8 phyper
      external phyper

      integer i, k
      real*8 di, dn, dn1s, dk, tprob

      dn1s = dfloat(n1s)
      dn = dfloat(nperm-n1s)
      
      k = 0
      dk = 0.0d0
      do 10 i = 1, nperm
         di = dfloat(i)
         tprob = phyper(dk, dn1s, dn, di, .true., .false.)
         if (tprob .le. eta0) then
            k = k+1
            dk = dk + 1.0d0
            ibdry(k) = i
         endif
 10   continue

      return
      end

      subroutine pexceed(nperm, n1s, ibdry, pexcd)
      integer nperm, n1s, ibdry(n1s)
      real*8 pexcd
c
Cf2py intent(in) nperm
Cf2py intent(in) n1s
Cf2py intent(in) ibdry
Cf2py intent(in,out) pexcd
c
      real*8 dn, dk, dn1, dk1, dn2, dk2, dn3, dk3, dlcnk
      integer i

      real*8 lchoose

      dn = dfloat(nperm)
      dk = dfloat(n1s)
      dn1 = dfloat(nperm-ibdry(1))
      dlcnk = lchoose(dn, dk)

      pexcd = exp(lchoose(dn1, dk) - dlcnk)

      if (n1s .ge. 2) then
         dn1 = dfloat(ibdry(1))
         dn = dfloat(nperm-ibdry(2))
         dk = dfloat(n1s-1)
         pexcd = pexcd + exp(log(dn1) + lchoose(dn, dk) - dlcnk)
      endif

      if (n1s .ge. 3) then
         dn1 = dfloat(ibdry(1))
         dn2 = dfloat(ibdry(2))
         dn = dfloat(nperm-ibdry(3))
         dk = dfloat(n1s-2)
         pexcd = pexcd + 
     1        exp(log(dn1) + log(dn1-1.0) - log(2.0) + 
     2                        lchoose(dn, dk) - dlcnk) +
     3        exp(log(dn1) + log(dn2-dn1) + lchoose(dn, dk) - dlcnk)
      endif

      if (n1s .gt. 3) then
         do 10 i = 4, n1s
            dn1 = dfloat(ibdry(i-3))
            dk1 = dfloat(i-1)
            dk2 = dfloat(i-2)
            dk3 = dfloat(i-3)
            dn2 = dfloat(ibdry(i-2))
            dn3 = dfloat(ibdry(i-1))
            dn = dfloat(nperm-ibdry(i))
            dk = dfloat(n1s-i+1)
            pexcd = pexcd + 
     1           exp(lchoose(dn1, dk1) + lchoose(dn, dk) - dlcnk) +
     2           exp(lchoose(dn1, dk2) + log(dn3-dn1) + 
     3                       lchoose(dn, dk) - dlcnk) +
     4           exp(lchoose(dn1, dk3) + log(dn2-dn1) + log(dn3-dn2) +
     3                        lchoose(dn, dk) - dlcnk) +
     5           exp(lchoose(dn1, dk3) + log(dn2-dn1) - log(2.0) + 
     6                    log(dn2-dn1-1.0) + lchoose(dn, dk) - dlcnk)
 10      continue
      endif

      return
      end

c     new approach to maximizing t-statistic
c     dynamic memory allocation using allocatable arrays 
      subroutine tmaxo(n,x,tss,sx,iseg,ostat,al0,ibin)
      integer n,iseg(2),al0
      real*8 x(n),tss,sx(n),ostat
      logical ibin
c      
Cf2py integer intent(in),depend(x) :: n=shape(x,0)
Cf2py intent(in) x
Cf2py intent(in) tss
Cf2py real*8 intent(in),depend(n) :: sx
Cf2py intent(in,out) iseg
Cf2py intent(in,out) ostat
Cf2py intent(in) al0
Cf2py intent(in) ibin
c     
c     look at the partial sums in blocks of size sqrt(n)
c     
      integer ipsmin, ipsmax, ipsmin0, ipsmax0, nb, i, j, k, l, nb1,
     1     nb2, bi, bj, ilo, ihi, jlo, jhi, alenmax, i2j, sxmxi,
     2     alenlo, alenhi, tmaxi, tmaxj, ixlo, ixhi, nal0
      real*8 psum, psmin, psmax, psmin0, psmax0, bssmax,
     1     bsslim, rn, rj, rjhi, rjlo, rnjov1, sij1, sij2, sijmx0,
     2     absx, sxmx, bijbss, rnov2, psdiff
c     
c     use local arrays for working within blocks
c     block partial sum max and min 
      real*8, allocatable :: bpsmax(:), bpsmin(:)
c     location of the max and min
      integer, allocatable :: bb(:), ibmin(:), ibmax(:)

c     t statistic corresponding to max for block i,j (and max possible)
      real*8, allocatable :: bssbij(:), bssijmax(:)
c     row, column and order vector for reordering bssbij
      integer, allocatable :: bloci(:), blocj(:), loc(:), alen(:)

      sxmxi = 0

c     calculate number of blocks (nb) and block boundaries (vector bb)
      rn = dfloat(n)
      if (n .ge. 50) then
         nb = nint(sqrt(dfloat(n)))
      else
         nb = 1
      endif

c     the number of paiwise block comparison
      nb2 = nb*(nb+1)/2
c     allocate memory
      allocate(bpsmax(nb), bpsmin(nb))
      allocate(bb(nb), ibmin(nb), ibmax(nb))
      allocate(bssbij(nb2), bssijmax(nb2))
      allocate(bloci(nb2), blocj(nb2), loc(nb2), alen(nb2))

c     block boundaries
      do 110 i = 1, nb
         bb(i) = nint(rn*(dfloat(i)/dfloat(nb)))
 110  continue

c     find the max, min of partial sums and their locations within blocks
      ilo = 1
      psum = 0
      psmin0 = 0
      psmax0 = 0
      ipsmin0 = n
      ipsmax0 = n
      do 20 j = 1, nb
         sx(ilo) = psum + x(ilo)
         psmin = sx(ilo)
         ipsmin = ilo
         psmax = sx(ilo)
         ipsmax = ilo
         do 10 i = ilo+1, bb(j)
            sx(i) = sx(i-1) + x(i)
            if (sx(i) .lt. psmin) then 
               psmin = sx(i)
               ipsmin = i
            endif
            if (sx(i) .gt. psmax) then 
               psmax = sx(i)
               ipsmax = i
            endif
 10      continue
c     store the block min, max and locations
         ibmin(j) = ipsmin
         ibmax(j) = ipsmax
         bpsmin(j) = psmin
         bpsmax(j) = psmax
c     adjust global min, max and locations
         if (psmin .lt. psmin0) then
            psmin0 = psmin
            ipsmin0 = ipsmin
         endif
         if (psmax .gt. psmax0) then
            psmax0 = psmax
            ipsmax0 = ipsmax
         endif
c     reset ilo to be the block boundary + 1
         psum = sx(bb(j))
         ilo = bb(j) + 1
 20   continue

c     calculate bss for max s_i - min s_i
      psdiff = psmax0 - psmin0
      rj = dfloat(abs(ipsmax0 - ipsmin0))
      rnjov1 = rn/(rj*(rn-rj))
      if (ibin) then
         bssmax = rnjov1*(psdiff-0.5)**2
      else
         bssmax = rnjov1*psdiff**2
      endif
      tmaxi = min(ipsmax0, ipsmin0)
      tmaxj = max(ipsmax0, ipsmin0)

c     if the segment is all constant then psdiff = 0 and so bssmax = 0
      if (psdiff .le. 0) then
         bssmax = 0
         go to 120
      endif

c     for a pair of blocks (i,j) calculate the max absolute t-statistic
c     at the (min_i, max_j) and (max_i, min_j) locations 
c     for other indices the t-statistic can be bounded using this
c
c     if a block doesn't have the potential to exceed bssmax ignore it
c     calculate the bsslim for each block and include ones >= bssmax

      rnov2 = rn/2
      l = 0
      nal0 = n - al0
      do 40 i = 1, nb
         do 30 j = i, nb
c     calculate bsslim
            if (i .eq. 1) then
               ilo = 1
            else
               ilo = bb(i-1) + 1
            endif
            ihi = bb(i)
            if (j .eq. 1) then
               jlo = 1
            else
               jlo = bb(j-1) + 1
            endif
            jhi = bb(j)
            alenhi = jhi - ilo
            if (alenhi .gt. nal0) alenhi = nal0
            rjhi = dfloat(alenhi)
            if (i .eq. j) then
               alenlo = 1
            else
               alenlo = jlo - ihi
            endif
            if (alenlo .lt. al0) alenlo = al0
c     max S_k over block j - min S_k over block i
            sij1 = abs(bpsmax(j) - bpsmin(i))
c     max S_k over block i - min S_k over block j
            sij2 = abs(bpsmax(i) - bpsmin(j))
c     if i = j then sij1 and sij2 are the same
            sijmx0 = max(sij1, sij2)
            rjlo = dfloat(alenlo)
            rnjov1 = rn/min(rjlo*(rn-rjlo), rjhi*(rn-rjhi))
            if (ibin) then
               bsslim = rnjov1*(sijmx0-0.5)**2
            else
               bsslim = rnjov1*(sijmx0**2)
            endif
c     if its as large as bssmax add block
            if (bssmax .le. bsslim) then
               l = l+1
               loc(l) = l
               bloci(l) = i
               blocj(l) = j
               bssijmax(l) = bsslim
c     max sij in the (i,j) block, t-statistic etc
               if (sij1 .gt. sij2) then
                  alen(l) = abs(ibmax(j) - ibmin(i))
                  rj = dfloat(alen(l))
                  rnjov1 = rn/(rj*(rn-rj))
                  if (ibin) then
                     bssbij(l) = rnjov1*(sij1-0.5)**2
                  else
                     bssbij(l) = rnjov1*(sij1**2)
                  endif
               else
                  alen(l) = abs(ibmin(j) - ibmax(i))
                  rj = dfloat(alen(l))
                  rnjov1 = rn/(rj*(rn-rj))
                  if (ibin) then
                     bssbij(l) = rnjov1*(sij2-0.5)**2
                  else
                     bssbij(l) = rnjov1*(sij2**2)
                  endif
               endif
            endif
 30      continue
 40   continue
      nb1 = l

c     Now sort the t-statistics by their magnitude
      call sort_i(bssbij, loc, 1, nb1)

c     now go through the blocks in reverse order (largest down)
      do 100 l = nb1, 1, -1
         k = loc(l)
c     need to check a block only if it has potential to increase bss
c     rjlo is the smalllest (j-i) in the block and rjhi is the largest
         bsslim = bssijmax(k)
         if (bssmax .le. bsslim) then
c     bi, bj give the block location
            bi = bloci(k)
            bj = blocj(k)
c     max arc length of interest in block
            alenmax = alen(k)
            if (bi .eq. 1) then
               ilo = 1
            else
               ilo = bb(bi-1) + 1
            endif
            ihi = bb(bi)
            if (bj .eq. 1) then
               jlo = 1
            else
               jlo = bb(bj-1) + 1
            endif
            jhi = bb(bj)
            alenhi = jhi - ilo
            if (alenhi .gt. nal0) alenhi = nal0
            rjhi = dfloat(alenhi)
            if (bi .eq. bj) then
               alenlo = 1
            else
               alenlo = jlo - ihi
            endif
            if (alenlo .lt. al0) alenlo = al0
            rjlo = dfloat(alenlo)
c
c     if arc length is larger than n/2 make is n - arc length
c
            if (alenmax .gt. n - alenmax) alenmax = n - alenmax
c
c     if alenlo <= n/2 start from (ihi, jlo) and go up
c     if alenhi >= n/2 start from (ilo, jhi) and go down
c
            if ((rjlo .le. rnov2) .and. (alenlo .le. alenmax)) then
               do 60 i2j = alenlo, alenmax
c     excess calcultaions to set range of i
                  ixlo = max(0, jlo - ilo - i2j)
                  ixhi = max(0, ihi + i2j - jhi)
                  sxmx = 0
                  do 55 i = ilo + ixlo, ihi - ixhi
                     j = i+i2j
                     absx = abs(sx(j) - sx(i))
                     if (sxmx .lt. absx) then
                        sxmx = absx
                        sxmxi = i
                     endif
 55               continue
                  rj = dfloat(i2j)
                  rnjov1 = rn/(rj*(rn-rj))
                  if (ibin) then
                     bijbss = rnjov1*(sxmx-0.5)**2
                  else
                     bijbss = rnjov1*(sxmx**2)
                  endif
                  if (bijbss .gt. bssmax) then
                     bssmax = bijbss
                     tmaxi = sxmxi
                     tmaxj = sxmxi + i2j
                  endif
 60            continue
            endif
c
c     make arclength n - arc length
c
            alenmax = n - alenmax
            if ((rjhi .ge. rnov2) .and. (alenhi .ge. alenmax)) then
               do 70 i2j = alenhi, alenmax, -1
c     excess calcultaions to set range of i
                  ixlo = max(0, jlo - ilo - i2j)
                  ixhi = max(0, ihi + i2j - jhi)
                  sxmx = 0
                  do 65 i = ilo + ixlo, ihi - ixhi
                     j = i + i2j
                     absx = abs(sx(j) - sx(i))
                     if (sxmx .lt. absx) then
                        sxmx = absx
                        sxmxi = i
                     endif
 65               continue
                  rj = dfloat(i2j)
                  rnjov1 = rn/(rj*(rn-rj))
                  if (ibin) then
                     bijbss = rnjov1*(sxmx-0.5)**2
                  else
                     bijbss = rnjov1*(sxmx**2)
                  endif
                  if (bijbss .gt. bssmax) then
                     bssmax = bijbss
                     tmaxi = sxmxi
                     tmaxj = sxmxi + i2j
                  endif
 70            continue
            endif
         endif
 100  continue

 120  if (ibin) then
         if (tss.le.0.0001) tss = 1.0
         bssmax = bssmax/(tss/rn)
      else
         if (tss.le.bssmax+0.0001) tss = bssmax + 1.0
         bssmax = bssmax/((tss-bssmax)/(rn-2.0))
      endif

c     deallocate memory
      deallocate(bpsmax, bpsmin, bb, ibmin, ibmax)
      deallocate(bssbij, bssijmax, bloci, blocj, loc, alen)

      ostat = bssmax
      iseg(1) = tmaxi
      iseg(2) = tmaxj

      return
      end

c     function for calculating the full max t-statistic on permuted data
c     new approach to maximizing t-statistic using allocatable arrays 
      real*8 function tmaxp(n,tss,px,sx,al0,ibin)
      integer n,al0
      real*8 tss,px(n),sx(n)
      logical ibin
c     
Cf2py integer intent(in),depend(px) :: n=shape(px,0)
Cf2py intent(in) tss
Cf2py intent(in) px
Cf2py real*8 intent(in),depend(n) :: sx
Cf2py intent(in) al0
Cf2py intent(in) ibin
Cf2py intent(out) tmaxp
c
c     look at the partial sums in blocks of size sqrt(n)
c     
      integer ipsmin, ipsmax, ipsmin0, ipsmax0, nb, i, j, k, l, nb1,
     1     nb2, bi, bj, ilo, ihi, jlo, jhi, alenmax, i2j, alenlo,
     2     alenhi, ixlo, ixhi, nal0
      real*8 psum, psmin, psmax, psmin0, psmax0, bssmax,
     1     bsslim, rn, rj, rjhi, rjlo, rnjov1, sij1, sij2, sijmx0,
     2     absx, sxmx, bijbss, rnov2, psdiff
c     
c     use local arrays for working within blocks
c     block partial sum max and min 
      real*8, allocatable :: bpsmax(:), bpsmin(:)
c     location of the max and min
      integer, allocatable :: bb(:), ibmin(:), ibmax(:)

c     t statistic corresponding to max for block i,j (and max possible)
      real*8, allocatable :: bssbij(:), bssijmax(:)
c     row, column and order vector for reordering bssbij
      integer, allocatable :: bloci(:), blocj(:), loc(:), alen(:)

c     calculate number of blocks (nb) and block boundaries (vector bb)
      rn = dfloat(n)
      if (n .ge. 50) then
         nb = nint(sqrt(dfloat(n)))
      else
         nb = 1
      endif

c     the number of paiwise block comparison
      nb2 = nb*(nb+1)/2
c     allocate memory
      allocate(bpsmax(nb), bpsmin(nb))
      allocate(bb(nb), ibmin(nb), ibmax(nb))
      allocate(bssbij(nb2), bssijmax(nb2))
      allocate(bloci(nb2), blocj(nb2), loc(nb2), alen(nb2))

c     block boundaries
      do 110 i = 1, nb
         bb(i) = nint(rn*(dfloat(i)/dfloat(nb)))
 110  continue

c     find the max, min of partial sums and their locations within blocks
      ilo = 1
      psum = 0
      psmin0 = 0
      psmax0 = 0
      ipsmin0 = n
      ipsmax0 = n
      do 20 j = 1, nb
         sx(ilo) = psum + px(ilo)
         psmin = sx(ilo)
         ipsmin = ilo
         psmax = sx(ilo)
         ipsmax = ilo
         do 10 i = ilo+1, bb(j)
            sx(i) = sx(i-1) + px(i)
            if (sx(i) .lt. psmin) then 
               psmin = sx(i)
               ipsmin = i
            endif
            if (sx(i) .gt. psmax) then 
               psmax = sx(i)
               ipsmax = i
            endif
 10      continue
c     store the block min, max and locations
         ibmin(j) = ipsmin
         ibmax(j) = ipsmax
         bpsmin(j) = psmin
         bpsmax(j) = psmax
c     adjust global min, max and locations
         if (psmin .lt. psmin0) then
            psmin0 = psmin
            ipsmin0 = ipsmin
         endif
         if (psmax .gt. psmax0) then
            psmax0 = psmax
            ipsmax0 = ipsmax
         endif
c     reset ilo to be the block boundary + 1
         psum = sx(bb(j))
         ilo = bb(j) + 1
 20   continue

c     calculate bss for max s_i - min s_i
      psdiff = psmax0 - psmin0
      rj = dfloat(abs(ipsmax0 - ipsmin0))
      rnjov1 = rn/(rj*(rn-rj))
      if (ibin) then
         bssmax = rnjov1*(psdiff-0.5)**2
      else
         bssmax = rnjov1*psdiff**2
      endif

c     for a pair of blocks (i,j) calculate the max absolute t-statistic
c     at the (min_i, max_j) and (max_i, min_j) locations 
c     for other indices the t-statistic can be bounded using this
c
c     if a block doesn't have the potential to exceed bssmax ignore it
c     calculate the bsslim for each block and include ones >= bssmax

      rnov2 = rn/2
      l = 0
      nal0 = n - al0
      do 40 i = 1, nb
         do 30 j = i, nb
c     calculate bsslim
            if (i .eq. 1) then
               ilo = 1
            else
               ilo = bb(i-1) + 1
            endif
            ihi = bb(i)
            if (j .eq. 1) then
               jlo = 1
            else
               jlo = bb(j-1) + 1
            endif
            jhi = bb(j)
            alenhi = jhi - ilo
            if (alenhi .gt. nal0) alenhi = nal0
            rjhi = dfloat(alenhi)
            if (i .eq. j) then
               alenlo = 1
            else
               alenlo = jlo - ihi
            endif
            if (alenlo .lt. al0) alenlo = al0
c     max S_k over block j - min S_k over block i
            sij1 = abs(bpsmax(j) - bpsmin(i))
c     max S_k over block i - min S_k over block j
            sij2 = abs(bpsmax(i) - bpsmin(j))
c     if i = j then sij1 and sij2 are the same
            sijmx0 = max(sij1, sij2)
            rjlo = dfloat(alenlo)
            rnjov1 = rn/min(rjlo*(rn-rjlo), rjhi*(rn-rjhi))
            if (ibin) then
               bsslim = rnjov1*(sijmx0-0.5)**2
            else
               bsslim = rnjov1*(sijmx0**2)
            endif
c     if its as large as bssmax add block
            if (bssmax .le. bsslim) then
               l = l+1
               loc(l) = l
               bloci(l) = i
               blocj(l) = j
               bssijmax(l) = bsslim
c     max sij in the (i,j) block, t-statistic etc
               if (sij1 .gt. sij2) then
                  alen(l) = abs(ibmax(j) - ibmin(i))
                  rj = dfloat(alen(l))
                  rnjov1 = rn/(rj*(rn-rj))
                  if (ibin) then
                     bssbij(l) = rnjov1*(sij1-0.5)**2
                  else
                     bssbij(l) = rnjov1*(sij1**2)
                  endif
               else
                  alen(l) = abs(ibmin(j) - ibmax(i))
                  rj = dfloat(alen(l))
                  rnjov1 = rn/(rj*(rn-rj))
                  if (ibin) then
                     bssbij(l) = rnjov1*(sij2-0.5)**2
                  else
                     bssbij(l) = rnjov1*(sij2**2)
                  endif
               endif
            endif
 30      continue
 40   continue
      nb1 = l

c     Now sort the t-statistics by their magnitude
      call sort_i(bssbij, loc, 1, nb1)

c     now go through the blocks in reverse order (largest down)
      do 100 l = nb1, 1, -1
         k = loc(l)
c     need to check a block only if it has potential to increase bss
c     rjlo is the smalllest (j-i) in the block and rjhi is the largest
         bsslim = bssijmax(k)
         if (bssmax .le. bsslim) then
c     bi, bj give the block location
            bi = bloci(k)
            bj = blocj(k)
c     max arc length of interest in block
            alenmax = alen(k)
            if (bi .eq. 1) then
               ilo = 1
            else
               ilo = bb(bi-1) + 1
            endif
            ihi = bb(bi)
            if (bj .eq. 1) then
               jlo = 1
            else
               jlo = bb(bj-1) + 1
            endif
            jhi = bb(bj)
            alenhi = jhi - ilo
            if (alenhi .gt. nal0) alenhi = nal0
            rjhi = dfloat(alenhi)
            if (bi .eq. bj) then
               alenlo = 1
            else
               alenlo = jlo - ihi
            endif
            if (alenlo .lt. al0) alenlo = al0
            rjlo = dfloat(alenlo)
c
c     if arc length is larger than n/2 make is n - arc length
c
            if (alenmax .gt. n - alenmax) alenmax = n - alenmax
c
c     if alenlo <= n/2 start from (ihi, jlo) and go up
c     if alenhi >= n/2 start from (ilo, jhi) and go down
c
            if ((rjlo .le. rnov2) .and. (alenlo .le. alenmax)) then
               do 60 i2j = alenlo, alenmax
c     excess calcultaions to set range of i
                  ixlo = max(0, jlo - ilo - i2j)
                  ixhi = max(0, ihi + i2j - jhi)
                  sxmx = 0
                  do 55 i = ilo + ixlo, ihi - ixhi
                     j = i+i2j
                     absx = abs(sx(j) - sx(i))
                     if (sxmx .lt. absx) sxmx = absx
 55               continue
                  rj = dfloat(i2j)
                  rnjov1 = rn/(rj*(rn-rj))
                  if (ibin) then
                     bijbss = rnjov1*(sxmx-0.5)**2
                  else
                     bijbss = rnjov1*(sxmx**2)
                  endif
                  if (bijbss .gt. bssmax) bssmax = bijbss
 60            continue
            endif
c
c     make arclength n - arc length
c
            alenmax = n - alenmax
            if ((rjhi .ge. rnov2) .and. (alenhi .ge. alenmax)) then
               do 70 i2j = alenhi, alenmax, -1
c     excess calcultaions to set range of i
                  ixlo = max(0, jlo - ilo - i2j)
                  ixhi = max(0, ihi + i2j - jhi)
                  sxmx = 0
                  do 65 i = ilo + ixlo, ihi - ixhi
                     j = i + i2j
                     absx = abs(sx(j) - sx(i))
                     if (sxmx .lt. absx) sxmx = absx
 65               continue
                  rj = dfloat(i2j)
                  rnjov1 = rn/(rj*(rn-rj))
                  if (ibin) then
                     bijbss = rnjov1*(sxmx-0.5)**2
                  else
                     bijbss = rnjov1*(sxmx**2)
                  endif
                  if (bijbss .gt. bssmax) bssmax = bijbss
 70            continue
            endif
         endif
 100  continue

      if (ibin) then
         if (tss.le.0.0001) tss = 1.0
         tmaxp = bssmax/(tss/rn)
      else
         if (tss.le.bssmax+0.0001) tss = bssmax + 1.0
         tmaxp = bssmax/((tss-bssmax)/(rn-2.0))
      endif

c     deallocate memory
      deallocate(bpsmax, bpsmin, bb, ibmin, ibmax)
      deallocate(bssbij, bssijmax, bloci, blocj, loc, alen)

      return
      end

c     function for the max (over small arcs) t-statistic on permuted data
c     new code to speed up this part 3/31/2010
      real*8 function htmaxp(n,k,tss,px,sx,al0,ibin)
      integer n,k,al0
      real*8 tss,px(n),sx(n)
      logical ibin

      integer i, j, nmj
      real*8 rn, rj, absx, sxmx, bssmx, psmin, psmax, psdiff,
     1     bsslim, rnjov1
c
Cf2py integer intent(in),depend(px) :: n=shape(px,0)
Cf2py intent(in) k
Cf2py intent(in) tss
Cf2py intent(in) px
Cf2py real*8 intent(in),depend(n) :: sx
Cf2py intent(in) al0
Cf2py intent(in) ibin
Cf2py intent(out) htmaxp
c
c     create blocks of size k (or k+1) to span 1 thru n
c     block partial sum max and min 
      real*8, allocatable :: bpsmax(:), bpsmin(:)
c     location of the max and min
      integer, allocatable :: bb(:)
c     variables to work on block specific data
      integer nb, ilo, ihi, l
      real*8 psum, psdiffsq

      rn = dfloat(n)
c     number of blocks of size k (plus fraction since n/k may not be integer)
      nb = int(rn/dfloat(k))
c     allocate memory
      allocate(bpsmax(nb), bpsmin(nb))
      allocate(bb(nb))
c     block boundaries
      do 110 i = 1, nb
         bb(i) = nint(rn*(dfloat(i)/dfloat(nb)))
 110  continue

c     don't need global min and max
c     find the max, min of partial sums and their locations within blocks
      ilo = 1
      psum = 0
      htmaxp = 0.0d0
      do 20 j = 1, nb
         sx(ilo) = psum + px(ilo)
         psmin = sx(ilo)
         ipsmin = ilo
         psmax = sx(ilo)
         ipsmax = ilo
         do 10 i = ilo+1, bb(j)
            sx(i) = sx(i-1) + px(i)
            if (sx(i) .lt. psmin) then 
               psmin = sx(i)
               ipsmin = i
            endif
            if (sx(i) .gt. psmax) then 
               psmax = sx(i)
               ipsmax = i
            endif
 10      continue
c     store the block min, max and locations
         bpsmin(j) = psmin
         bpsmax(j) = psmax
c     reset ilo to be the block boundary + 1
         psum = sx(bb(j))
         ilo = bb(j) + 1
c     calculate the bss at the block max & min pr
         i = abs(ipsmin - ipsmax)
         if ((i .le. k) .and. (i .ge. al0)) then
            rj = dfloat(i)
            rnjov1 = rn/(rj*(rn-rj))
            if (ibin) then
               bssmx = rnjov1*(bpsmax(j) - bpsmin(j) -0.5)**2
            else
               bssmx = rnjov1*(bpsmax(j) - bpsmin(j))**2
            endif
            if (htmaxp .lt. bssmx) htmaxp = bssmx
         endif
 20   continue

c     check the first block
      ilo = 1
      ihi = bb(1)
      psdiff = bpsmax(1) - bpsmin(1)
      if (ibin) then
         psdiffsq = (psdiff-0.5)**2
      else
         psdiffsq = psdiff**2
      endif
      do 40 j = al0,k
         rj = dfloat(j)
         rnjov1 = rn/(rj*(rn-rj))
         bsslim = rnjov1*psdiffsq
         if (bsslim .lt. htmaxp) go to 50
         sxmx = 0.0d0
         do 30 i = ilo,ihi-j
            absx = abs(sx(i+j) - sx(i))
            if (sxmx.lt.absx) sxmx = absx
 30      continue
         if (ibin) then
            bssmx = rnjov1*(abs(sxmx)-0.5)**2
         else
            bssmx = rnjov1*sxmx**2
         endif
         if (htmaxp.lt.bssmx) htmaxp = bssmx
 40   continue

c     now the minor arcs spanning the end (n)
 50   psdiff = max(abs(bpsmax(1)-bpsmin(nb)), abs(bpsmax(nb)-bpsmin(1)))
      if (ibin) then
         psdiffsq = (psdiff-0.5)**2
      else
         psdiffsq = psdiff**2
      endif
      do 70 j = al0,k
         rj = dfloat(j)
         rnjov1 = rn/(rj*(rn-rj))
         bsslim = rnjov1*psdiffsq
         if (bsslim .lt. htmaxp) go to 100
         sxmx = 0.0d0
         nmj = n-j
         do 60 i = 1,j
            absx = abs(sx(i+nmj) - sx(i))
            if (sxmx.lt.absx) sxmx = absx
 60      continue
         if (ibin) then
            bssmx = rnjov1*(abs(sxmx)-0.5)**2
         else
            bssmx = rnjov1*sxmx**2
         endif
         if (htmaxp.lt.bssmx) htmaxp = bssmx
 70   continue

c     now the other blocks
 100  do 200 l = 2,nb
         ilo = bb(l-1)+1
         ihi = bb(l)
         psdiff = bpsmax(l) - bpsmin(l)
         if (ibin) then
            psdiffsq = (psdiff-0.5)**2
         else
            psdiffsq = psdiff**2
         endif
         do 140 j = al0,k
            rj = dfloat(j)
            rnjov1 = rn/(rj*(rn-rj))
            bsslim = rnjov1*psdiffsq
            if (bsslim .lt. htmaxp) go to 150
            sxmx = 0.0d0
            do 130 i = ilo,ihi-j
               absx = abs(sx(i+j) - sx(i))
               if (sxmx.lt.absx) sxmx = absx
 130        continue
            if (ibin) then
               bssmx = rnjov1*(abs(sxmx)-0.5)**2
            else
               bssmx = rnjov1*sxmx**2
            endif
            if (htmaxp.lt.bssmx) htmaxp = bssmx
 140     continue
 150     psdiff = max(abs(bpsmax(l)-bpsmin(l-1)), 
     1        abs(bpsmax(l-1)-bpsmin(l)))
         if (ibin) then
            psdiffsq = (psdiff-0.5)**2
         else
            psdiffsq = psdiff**2
         endif
         do 170 j = al0,k
            rj = dfloat(j)
            rnjov1 = rn/(rj*(rn-rj))
            bsslim = rnjov1*psdiffsq
            if (bsslim .lt. htmaxp) go to 200
            sxmx = 0.0d0
            nmj = n-j
            do 160 i = ilo-j,ilo-1
               absx = abs(sx(i+j) - sx(i))
               if (sxmx.lt.absx) sxmx = absx
 160        continue
            if (ibin) then
               bssmx = rnjov1*(abs(sxmx)-0.5)**2
            else
               bssmx = rnjov1*sxmx**2
            endif
            if (htmaxp.lt.bssmx) htmaxp = bssmx
 170     continue
 200  continue
      if (ibin) then
         if (tss .le. 0.0001d0) tss = 1.0d0
         htmaxp = htmaxp/(tss/rn)
      else
         if (tss .le. htmaxp+0.0001d0) tss = htmaxp + 1.0d0
         htmaxp = htmaxp/((tss-htmaxp)/(rn-2.0d0))
      endif

c     deallocate memory
      deallocate(bpsmax, bpsmin, bb)

      return
      end

      subroutine make_KMP_table(T, W, N)
      integer T(0:(N-1)), N
      character W(0:(N-1))
c
Cf2py intent(in,out) T
Cf2py intent(in) W
Cf2py integer intent(hide),depend(T) :: N=shape(T, 0)
c
      integer pos, cnd
      T(0) = -1
      pos = 1
      cnd = 0
      do 10 while (pos .lt. N)
        if (W(pos) .eq. W(cnd)) then
          T(pos) = T(cnd)
          pos = pos + 1
          cnd = cnd + 1
        else
          T(pos) = cnd
          cnd = T(cnd)
          do 20 while ((cnd .ge. 0) .AND. (W(pos) .ne. W(cnd)))
            cnd = T(cnd)
20        continue
          pos = pos + 1
          cnd = cnd + 1
        endif
10    continue
      return
      end

      integer function overlap(W, S, T, N, M)
      character W(0:(N-1)), S(0:(M-1))
      integer T(0:(N-1)), N, M
c
Cf2py intent(in) W
Cf2py intent(in) S
Cf2py intent(in) T
Cf2py integer intent(hide),depend(W) :: N=shape(W,0)
Cf2py integer intent(hide),depend(S) :: M=shape(S,0)
c
      integer j, k, l
      j = 0
      k = 0
      if (N .lt. M) then
        l = N
      else
        l = M
      endif
      do 10 while (j .lt. l)
        if (W(k) .eq. S(j)) then
          j = j + 1
          k = k + 1
        else
          k = T(k)
          if (k .lt. 0) then
            j = j + 1
            k = k + 1
          endif
        endif
10    continue
      overlap = k
      return
      end

c     tail probability of circular binary segmentation statistic
c     from Siegmund (1988) or Yao (1989) paper
      double precision function tailp(b, delta, m, ngrid, tol)
      double precision b, delta, tol
      integer m, ngrid
c
Cf2py intent(in) b
Cf2py intent(in) delta
Cf2py intent(in) m
Cf2py intent(in) ngrid
Cf2py intent(in) tol
Cf2py intent(out) tailp
c
c     it1tsq is the integral of 1/(t*(1-t))**2
      double precision nu, it1tsq
      external nu, it1tsq

      double precision t, tl, dincr, bsqrtm, x, nux
      integer i

      dincr = (0.5d0 - delta)/dfloat(ngrid)
      bsqrtm = b/sqrt(dfloat(m))

      tl = 0.5d0 - dincr
      t = 0.5d0 - 0.5d0*dincr
      tailp = 0.0d0
      do 10 i = 1,ngrid
         tl = tl + dincr
         t = t + dincr
         x = bsqrtm/sqrt(t*(1-t))
         nux = nu(x, tol)
         tailp = tailp + (nux**2)*it1tsq(tl, dincr)
 10   continue
      tailp = 9.973557d-2*(b**3)*exp(-b**2/2)*tailp
c     since test is two-sided need to multiply tailp by 2
      tailp = 2.0d0*tailp

      return
      end

c     integral of 1/(t*(1-t))**2 from x to x+a
      double precision function it1tsq(x, a)
      double precision x, a
c
Cf2py intent(in) x
Cf2py intent(in) a
Cf2py intent(out) it1tsq
c
      double precision y

      y = x + a - 0.5d0
      it1tsq = (8.0d0*y)/(1.0d0 - 4.0d0*y**2) + 
     1     2.0d0*log((1.0d0 + 2.0d0*y)/(1.0d0 - 2.0d0*y))
      y = x - 0.5d0
      it1tsq = it1tsq - (8.0d0*y)/(1.0d0 - 4.0d0*y**2) -
     1     2.0d0*log((1.0d0 + 2.0d0*y)/(1.0d0 - 2.0d0*y))

      return
      end

      double precision function nu(x, tol)
      double precision x, tol
c
Cf2py intent(in) x
Cf2py intent(in) tol
Cf2py intent(out) nu
c
      double precision alnorm
      external alnorm

      double precision lnu0, lnu1, dk, xk
      integer i, k

      if (x .gt. 0.01d0) then
         lnu1 = log(2.0d0) - 2*log(x)
         lnu0 = lnu1
         k = 2
         dk = 0
         do 10 i = 1, k
            dk = dk + 1
            xk = -x*sqrt(dk)/2.0d0
            lnu1 = lnu1 - 2.0d0*alnorm(xk, 0)/dk
 10      continue

         do 50 while (dabs((lnu1-lnu0)/lnu1) .gt. tol)
            lnu0 = lnu1
            do 20 i = 1,k
               dk = dk + 1
               xk = -x*sqrt(dk)/2.0d0
               lnu1 = lnu1 - 2.0d0*alnorm(xk, 0)/dk
 20         continue
            k = 2*k
 50      enddo
      else
         lnu1 = -0.583d0*x
      endif
      nu = exp(lnu1)

      return
      end

c     tail probability of binary segmentation statistic
c     from page 387 of Siegmund (1986) paper
      double precision function btailp(b, m, ng, tol)
      integer m, ng
      double precision b, tol
c
Cf2py intent(in) b
Cf2py intent(in) m
Cf2py intent(in) ng
Cf2py intent(in) tol
Cf2py intent(out) btailp
c
      double precision ll, ul, dincr, nulo, nuhi, x, x1, dm
      integer i, k

      double precision alnorm, nu
      external alnorm, nu

      dm = dfloat(m)
      k = 2
      ll = b*sqrt(1.0/dfloat(m-k) - 1.0/dfloat(m))
      ul = b*sqrt(1.0/dfloat(k) - 1.0/dfloat(m))
      dincr = (ul - ll)/dfloat(ng)

      btailp = 0.0
      x = ll
      x1 = x + (b**2)/(dm*x)
      nulo = nu(x1, tol)/x
      do 10 i = 1, ng
         x = x + dincr
         x1 = x + (b**2)/(dm*x)
         nuhi = nu(x1, tol)/x
         btailp = btailp + (nuhi + nulo)*dincr
         nulo = nuhi
 10   continue
      btailp = b*exp(-b**2/2)*btailp/2.506628275

      btailp =  btailp + 2*(1.0-alnorm(b, 0))

      return
      end
